#include "def.h"
#include "acostab.h"

static
int
pointSlope( Point p1, Point p0)
{
    int alpha;
    int dx2  = ( p1.x - p0.x ) * ( p1.x - p0.x );
    int hyp2 = dx2 + ( p1.y - p0.y ) * ( p1.y - p0.y );

    /* acos2_tab[x] = acos(sqrt(x/256)) */
    /*ce some bug catching -- good line to set a break-point ;-) */
    if ( hyp2 == 0 )
        return 0;
        
    alpha = acos2_tab[(256L * (long) dx2) / hyp2];
    if (p1.x < p0.x)
	alpha = (int)(C * PI) - alpha;
    return (p1.y < p0.y) ? ((int)(C * 2.0*PI) - alpha) : alpha;
}

int
calcSlopes( Pattern FAR *p )
{
    int i;

    unsigned char ascii;
    ascii=p->ascii;
    ascii++;
    ascii--;
/*ce used by makemod.c*/    
#ifdef CE_REUSE_SLOPE_MEM
    if ( p->s == NULL )
        p->s = (int FAR *) malloc( p->nPoints * sizeof( int ) );
#else
    if ( p->s != NULL )
	    free( p->s );
	    
    p->s = (int FAR *) malloc( p->nPoints * sizeof( int ) );
#endif
    if (p->s == NULL)
	return 0;
    if ( p->nPoints == 1 )
    {
	p->s[0] = 0;
	return 1;
    }

    for ( i = 0; i < p->nPoints - 1; i++ )
	p->s[i] = pointSlope( p->pv[ i + 1 ], p->pv[ i ] );
    p->s[ p->nPoints - 1 ] = p->s[ p->nPoints - 2 ];
    return 1;
}


/*ce calculate the information for pre-decission for a pattern */
void
calcPreDecideInfo( Pattern FAR *p )
{
    int maxx, maxy, i;
    Point far *ps;
    Point far *pe;

    /* minx/y is assumed to be 0; 
       this is true for all patterns in the model + for all input patterns _after pre-processing */
    /* could also use patternMinMax() here, if code size matters more than a little bit of speed */
    maxx = p->pv[0].x;
    maxy = p->pv[0].y;
    for ( i = 1; i < p->nPoints; i++ )
    {
	if (p->pv[i].x > maxx)
	    maxx = p->pv[i].x;
	if (p->pv[i].y > maxy)
	    maxy = p->pv[i].y;
    }

    /*boxshape-stuff did not work well
    p->boxshape = maxx - maxy;
    */
    ps = p->pv + 0;
    pe = p->pv + (p->nPoints-1);
    p->sev_x = (pe->x - ps->x) * (99.0/max(maxx,50.0));
    p->sev_y = (pe->y - ps->y) * (99.0/max(maxy,50.0));
    /* each vector-component in scaled as if the patterns 
       was squezzed into a square (but no more than by factor 2 */

}