/*********************************************************
 *
 * utility functions
 *
 * Copyright (c) 2001 Christian Ensel
 *
 *********************************************************/

#include <stdrom.h>
#include "define.h"
#include "libc.h"

/*static*/ 
TCHTBL far empty[] = { /*actionWheelTch[] = { /*ceV3.1 aus PV.c genommen*/
 /*       { 140,164, 164,177, ACT_MAKE, OBJ_HIC_ESC }, */
 /*      {  17,164, 139,200, ACT_MAKE, OBJ_MYHARDICON },  */
/*       { 0,0, 0,0, ACT_MAKE | ACT_REPEAT, OBJ_LPSW_UP }, 
       { 0,0, 0,0, ACT_MAKE , OBJ_LPSW_PUSH }, 
       { 0,0, 0,0, ACT_MAKE | ACT_REPEAT, OBJ_LPSW_DOWN }, */
       { 0,0,0,0,0,OBJ_END,0 }
};


/*ce extended version of LibSelWindowExt() */
/* automatically calculates width, 
   displays a menu title,
   allows rtv==null (returns the selected line nr)
   */
byte SelWindowExt2(int x, int y, char *title, byte sel, byte *items, byte *rtv )
{
    byte myrtv[16];
    byte result;
    SLW2_ST slw;
    int xsize, ysize;
    int titlesize;
    char *tmp;
    int w;
    int n=0;
    
    slw.ity=9;
    slw.np=sel;
    slw.t_xs=4;
    
    /* set return values */
    if ( rtv==NULL) {
        slw.rtv=myrtv;
    }
    else 
        slw.rtv=rtv;
    
    if (items==NULL)
        return 0; /* just in case ... */
    slw.cmnt=items;
    
    /* calc width + set myrtv */
    titlesize = LibGetProStrSize(IB_PFONT2, title)+5; /*buggy? values semm to be too small!*/
    if (titlesize>160)
        titlesize = 160;
    xsize = titlesize+6;
    items--;
    do {
        myrtv[n] = n;
        n++;
        items++;
        tmp = items;
        items = strchr(items, '\xfe');
        if (items!=NULL) /* not at the last item */
            *items=0;
        w = LibGetProStrSize(IB_PFONT1, tmp);
        if (items!=NULL) /* not at the last item */
            *items='\xfe';
        if (w > xsize)
            xsize = w;
    } while ( items!=NULL );
    
    xsize += slw.t_xs+4;
    if (xsize>160)
        xsize = 160;
    slw.xs=xsize;
    if (x==-1)
        x = (160-xsize)>>1;
    if (x+xsize>=160)
        x=160-xsize;
    slw.x=x;
    
    ysize = n*slw.ity + 6 + (title? 11 :0);
    if (y==-1)
        y = (160-ysize)>>1;
    if (y+ysize>=160)
        y=160-ysize;
    slw.y=y + (title? 11 :0);
    myrtv[n]=0xff;
   
    /* menu */
    if (title) {
        x = x+((xsize-titlesize)>>1);
        LibOpenWindow(x,y, titlesize, 11);
        /*LibBox( x,y, xsize, 10, 1);*/
        LibPutProStr(IB_PFONT2, x+3, y+3, title, titlesize );
        LibPutDispBox(x,y, titlesize, 11);
    }
    result = LibSelWindowExt(&slw);
    if (title) {
        LibCloseWindow();
        LibPutDispBox(x,y, titlesize, 11);
    }
    
    return result;
}



bool inSecretMode()
{
    word m_code;
    word m_sts; 
    word m_seg; 
    word m_ofs;
    LibGetMode(&m_code, &m_sts, &m_seg, &m_ofs);
    return ( (m_code & 0x8000) && SYS_PASS_MATCH );
}


/* gets current time, daylight-saving is taken into account */
void getTime(int *h, int *m, int *s)
{
    word y;
    byte mo,da,c_h,c_m,c_s;
    LibGetDateTime2( &y, &mo, &da, &c_h, &c_m, &c_s );
    *h = c_h>23 ?0 :c_h;
    *m = c_m>59 ?0 :c_m;
    *s = c_s>59 ?0 :c_s;
}

void getDate(word *py, int *pm, int *pd)
{
    word y;
    byte mo,da,c_h,c_m,c_s;
    LibGetDateTime2( &y, &mo, &da, &c_h, &c_m, &c_s );
    *py = y;
    *pm = mo>12 ?0 :mo;
    *pd = da>31 ?0 :da;
}

int printCharArray(int x, int y, char **txt, int width, byte font) 
{
    int i=0;
    while ( txt[i][0] != 0 ) {
        if ( txt[i][0] <= 4 && txt[i][0]>0 )
            y+=txt[i][0];
        else if ( txt[i][0] == 0xff ) { /* bold line */
            LibPutProStr( IB_PFONT2, x, y, txt[i]+1, width );
            y+=8;
        } else  {
            LibPutProStr( font, x, y, txt[i], width );
            y+=8;
        }
        i++;
    }
    return y;
}

/*TCHTBL far fullscreen_tchtbl[] = {
       { 0,0, 159, 159, ACT_BREAK_IN, OBJ_FULLSCREEN, 0x000 },
       { 0,0,0,0,ACT_NONE,OBJ_END,0x0000 }
};
*/

/* returns TRUE for normal touch, FALSE for <esc> */
int waitForClick()
{
    TCHSTS tsts;
    int res=TRUE;
    LibPutDisp();
    LibTchStackPush(NULL);
    LibTchStackPush(TchHardIcon);
    LibTchStackPush(TchAllDsp); /*fullscreen_tchtbl);*/
    LibTchStackPush(TchActionKey); /*actionWheelTch);*/
    do {
        LibTchWait(&tsts);
        /*LibPutMsgDlg2("%i",tsts.act);*/
    } while ( tsts.act != ACT_BREAK && tsts.act != ACT_BREAK_IN && tsts.obj!=OBJ_HIC_ESC 
              && tsts.obj!=OBJ_LPSW_DOWN && tsts.obj!=OBJ_LPSW_PUSH );
    LibTchStackPop();
    LibTchStackPop();
    LibTchStackPop();
    LibTchStackPop();
    if (tsts.obj==OBJ_HIC_ESC)
        res = FALSE;
    return res;
}

