/*********************************************************
 *
 * word completation
 *
 * Copyright (c) 2001 Christian Ensel
 *
 *********************************************************/

#ifndef KEYWORDS_H
#define KEYWORDS_H

#define MAXKEYWORDLEN 32  /* ce-new2 value changed */ /* max 32! */
#define MINKEYWORDLEN 6
#define MAXKEYWORDS 3
#define OBJ_KEYWORD 0x8010

/* call once at prog-start */
void initKeyword();

/* add all keywords in txt */
void addKeywords(char *txt);

/* are keyword available? */
bool keywordsAvailable();

/* show window with keywords, add window touchtable */
/* (x,y) is 'close to window, but always left uncovered by window*/
void openKeywordWindow(int x, int y);
void closeKeywordWindow();
void putDispAtKeywordWindow();

/* after click on keyword-window, this gives the result */
char* getKeywordRemainder(TCHSTS* p_tsts);
char* getKeywordRemainderAt(int sel);

/* clear prefix buffer */
void resetKeywordprefix();

void rereadKeywordPrefix(char *txt, int cp);

/* call after backspace, otherwise pefixbuffer will be cleared at next check */
void delLastCharFromKeywordPrefix();

/* - adds chars before cursor position cp in textbuffer txt to current
     keyword-prefix (=new input compared with stored keywords).
   - checks if current keywords match prefix
   - adds new words to keyword-buffer, if a word is completed
   - function able to cope with cursor replacements  */
void checkKeywordPrefix(char *txt, int cp);

/* same, but dont check keywords, just update keyword prefix */
void updateKeywordPrefix(char *txt, int cp);

bool isInternationalAlphaNum(char c);

#endif