
#ifndef LOADSAVE_H
#define LOADSAVE_H


#define NEWFILE 0xffff

/* Save text pointed by arg to a new memo */
int savetext(char *txtbuf, word *p_fp, int *p_cat);

/* Save text pointed by arg to a new memo and sorts it after prev_fp */
int savetextAt(char *txtbuf, word *p_fp, int *p_cat, word prev_fp );

/* Load a memo to the buffer pointed by arg */
int loadtext(char *txtbuf, char *title, word *p_fp, int *p_cat);

/* search direction for loadpage(): 
   Load next/prev. Memo with same title 
   SEARCH_THIS_PAGE is used to perform no search, but to load the file at *p_fp, this is like a simplyfied LibFileRead(), then also set: title==NULL */
typedef enum { SEARCH_NEXT_PAGE, SEARCH_PREV_PAGE, SEARCH_THIS_PAGE } t_searchdir;

int loadpage(char *txtbuf, char *title, t_searchdir d, word *p_fp, int *p_cat);

/* delete a file */
int deletefile(word fp);


/* Displays a menu showing memo categories and returns number
 * corresponding to the one selected. 0 is All, 1..NUM_CATEGORIES are real
 * categories.  
 * if title!=NULL displays a title-string and does not allow to select "All"
 */
int selectcategory(int cat, char *title);


/* this defines the end of the main-title of a memo */
int istitleendchar(char c);
#define IS_TITLE_ENDCHAR(C) istitleendchar(C)
/*as a function it takes less code size (about 100 bytes ;-)*/
/*(C=='-' || C==':' || C=='(' || C=='[' || C=='\r' || C==0 || C==0xfe )*/

#endif