/*********************************************************
 *
 * generally used macros for parmameters of PV Merlin
 * must be consistent with string-definitions in PV.c
 *
 * Copyright (c) 2001 Christian Ensel
 *
 *********************************************************/

#ifndef PARAMS_H
#define PARAMS_H

#ifdef TEST
  #ifdef ALLOWDEBUGCODE
    #define NR_PARAMS 14
  #else
    #define NR_PARAMS 13
  #endif
#else /* older than V3.2 */
  #define NR_PARAMS 12
#endif

#define PARAM_WRITING_STYLE 0
typedef enum { P_NORMAL, P_CURSIVE } t_p_writing_style;  /* type (enum) not used, only constants */

#define PARAM_SELECTION_TIME_THRESHOLD 1
typedef enum { P_STT_NORMAL, P_STT_VERYSHORT, P_STT_SHORT, P_STT_LONG } t_p_selection_time_threshold; 

#define PARAM_MERLIN_WITH_KEYBOARD 2
typedef enum { P_MWKEYBOARD_ON, P_MWKEYBOARD_OFF } t_p_mwkeyboard; 

#define PARAM_FONT 3
#ifdef TEST
  typedef enum { P_FONT_NORMAL, P_FONT_BOLD, P_FONT_NONPROP } t_p_font; 
#else
  typedef enum { P_FONT_NORMAL, P_FONT_BOLD } t_p_font; 
#endif

#define PARAM_LINESPACING 4
typedef enum { P_LS_NORMAL, P_LS_NARROW } t_p_linespacing;  

#define PARAM_SHOWRET 5
typedef enum { P_SR_OFF, P_SR_ON } t_p_sr;  

#define PARAM_KEYWORDS 6
typedef enum { P_KW_ON, P_KW_ON_NOLOAD, P_KW_OFF } t_p_keywords;  

#define PARAM_START_WITH 7
typedef enum { P_SW_LAST, P_SW_LOAD, P_SW_NEW } t_p_start_with;  

#define PARAM_SAVE_ON_EXIT  8
typedef enum { P_EXITSAVE_ASK, P_EXITSAVE_ALWAYS } t_p_save_on_exit; 

#define PARAM_LPS  9  
typedef enum { P_LPS_PARAGRAPH, P_LPS_PAGE, P_LPS_MEMO, P_LPS_TIME } t_p_lps; /* changes of this parameter misu be reflected in leverPushMenu() */

#ifdef TEST
  #define PARAM_TIMEFORMAT  10
  typedef enum { P_TF_NDTA, P_TF_NT, P_TF_TD, P_TF_N, P_TF_T, P_TF_D } t_p_timeformat; /* changes of this parameter misu be reflected in leverPushMenu() */

  #define PARAM_CHBUF  11
  typedef enum { P_CHBUF_500, P_CHBUF_200, P_CHBUF_ON, P_CHBUF_OFF} t_p_chbuf; 

  #define PARAM_CHBUFDELAY  12
  typedef enum { P_CHBUFDELAY_NORMAL, P_CHBUFDELAY_SHORT, P_CHBUFDELAY_LONG} t_p_chbufdelay; 
#endif

#ifdef ALLOWDEBUGCODE
 #ifdef TEST
  #define PARAM_DEBUG  13
 #else
  #define PARAM_DEBUG  10
 #endif
  typedef enum { P_DBG_NONE, P_DBG_PATTERN, P_DBG_PREPROC, P_DBG_KEYWORDS, P_DBG_FULL } t_p_debug; 
#endif

/* add new parameters here and in PV.c */


#define MAX_TITLE_LEN 45

/*data stored permanently in pvm-file */
typedef struct  {
    byte param_values[NR_PARAMS];
    /*byte mtxbf[2049]; /* Buffer for text input */
    int cursorpos;
    int currentcat;
    char fulltitle[MAX_TITLE_LEN+1];
} s_pvmerlin_permanent_data;

extern s_pvmerlin_permanent_data* p_pvmerlin_permanent_data;

/* macro to access the real parameters defined in PV.c */
#define PARAM(N) (p_pvmerlin_permanent_data->param_values[N])


#endif
