/*********************************************************
 * pattern.h
 *
 * Copyright (c) Stefan Hellkvist
 *********************************************************/

#ifndef PATTERN_H
#define PATTERN_H

#include "point.h"


struct pattern
{
    /* Public part. Use freely */
    Point FAR *pv;   /* A vector of points */
    int FAR *s;    /* The slope at these points */
    int nPoints; /* The number of points in the vector and slopes */
    unsigned char ascii; /* The meaning of this pattern */

    /* Private part. Don't mess around */
    int size;    /* The size of the vectors */

    /*ce Information for pre-decission */
    int sev_x;     /* start-end-vector stored in a Point */
    int sev_y;     /* -"- */
    /*ce did not work well: int boxshape;  /* dx_max - dy_max => +100:horizontal line; 0:quadrat -100:vertical line */
};

typedef struct pattern Pattern;

/* Creates a new pattern */
Pattern FAR *newPattern(int initialSize, unsigned char ascii);

/* Frees up a pattern */
void deletePattern(Pattern FAR *p);

/* Adds a point to a pattern */
void addPoint(Pattern FAR *p, Point po);

/* Calculates the slopes in a pattern */
int calcSlopes(Pattern FAR *p);

/*ce */
void calcPreDecideInfo( Pattern FAR *p );

/*ce */
void patternMinMax( Pattern FAR *p, int *xmin_result, int *xmax_result, int *ymin_result, int *ymax_result  );

#endif
